
package de.ivu.elect.business.aufgabe.boundary;

import javax.enterprise.context.RequestScoped;
import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;

import de.ivu.elect.business.aufgabe.entity.Aufgabe;

@RequestScoped
@Named(AufgabeConversationSelect.COMPONENT_NAME)
public class AufgabeConversationSelect implements java.io.Serializable {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "aufgabeConversationSelect";

  @Inject
  protected transient AufgabeExtendedDAO entityDAO;

  @Inject
  @ConversationGroup(AufgabeConversationStore.class)
  protected transient AufgabeConversationStore conversationStore;

  public AufgabeConversationSelect() {
    super();
  }

  public boolean isSelected() {
    return getEntityPK() != null;
  }

  public Aufgabe getEntity() {
    return getEntityInternal();
  }

  private Aufgabe getEntityInternal() {
    if (getEntityPK() == null) {
      return null;
    }

    return attach(getEntityPK());
  }

  public void setEntity(Aufgabe entity) {
    setEntityAttached(attach(entity));
  }

  public void setEntity( de.ivu.elect.business.aufgabe.entity.AufgabePK  pk) {
    setEntityAttached(attach(pk));
  }

  protected void setEntityAttached(Aufgabe entity) {
    if(entity == null) {
      setEntityPK(null);
    } else {
      setEntityPK(entity.getPk());
    }
  }

  public
    de.ivu.elect.business.aufgabe.entity.AufgabePK
   getEntityPK() {
    return conversationStore.getEntityPK();
  }

  public void setEntityPK(
    de.ivu.elect.business.aufgabe.entity.AufgabePK
   entityPK) {
    conversationStore.setEntityPK(entityPK);
  }

  protected Aufgabe attach(Aufgabe entity) {
    if (entity == null){
      return null;
    }

    return attach(entity.getPk());
  }

  protected Aufgabe attach( de.ivu.elect.business.aufgabe.entity.AufgabePK  pk) {
    if (pk == null) {
      return null;
    }

    return entityDAO.findByPrimaryKey(pk);
  }

  public void clearEntity() {
    setEntityPK(null);

    conversationStore.close();
  }
}
